﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Cascading_DropDownList_Razor_Core.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Cascading_DropDownList_Razor_Core.Pages
{
    public class IndexModel : PageModel
    {
        private DBCtx Context { get; }
        public IndexModel(DBCtx _context)
        {
            this.Context = _context;
        }

        public CascadingModel CascadingModel { get; set; }

        public void OnGet()
        {
            CascadingModel = new CascadingModel();
            CascadingModel.Countries = (from customer in this.Context.Countries
                                        select new SelectListItem
                                        {
                                            Value = customer.CountryId.ToString(),
                                            Text = customer.CountryName
                                        }).ToList();
        }

        [ValidateAntiForgeryToken]
        public JsonResult OnPostAjaxMethod(string type, int value)
        {
            CascadingModel = new CascadingModel();
            switch (type)
            {
                case "ddlCountries":
                    CascadingModel.States = (from customer in this.Context.States
                                             where customer.CountryId == value
                                             select new SelectListItem
                                             {
                                                 Value = customer.StateId.ToString(),
                                                 Text = customer.StateName
                                             }).ToList();
                    break;
                case "ddlStates":
                    CascadingModel.Cities = (from customer in this.Context.Cities
                                             where customer.StateId == value
                                             select new SelectListItem
                                             {
                                                 Value = customer.CityId.ToString(),
                                                 Text = customer.CityName
                                             }).ToList();
                    break;
            }
            return new JsonResult(CascadingModel);
        }

        public void OnPostSubmit(int countryId, int stateId, int cityId)
        {
            CascadingModel = new CascadingModel();
            CascadingModel.Countries = (from customer in this.Context.Countries
                                        select new SelectListItem
                                        {
                                            Value = customer.CountryId.ToString(),
                                            Text = customer.CountryName
                                        }).ToList();

            CascadingModel.States = (from customer in this.Context.States
                                     where customer.CountryId == countryId
                                     select new SelectListItem
                                     {
                                         Value = customer.StateId.ToString(),
                                         Text = customer.StateName
                                     }).ToList();

            CascadingModel.Cities = (from customer in this.Context.Cities
                                     where customer.StateId == stateId
                                     select new SelectListItem
                                     {
                                         Value = customer.CityId.ToString(),
                                         Text = customer.CityName
                                     }).ToList();

            CascadingModel.CountryId = countryId;
            CascadingModel.StateId = stateId;
            CascadingModel.CityId = cityId;
        }
    }
}